## icecc-monitor 2.0~svn951472

=== CMakeLists.txt ===
project(playground-devtools)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake/modules )

find_package(KDE4 REQUIRED)
include (KDE4Defaults)
include(MacroOptionalAddSubdirectory)
include(MacroOptionalDependPackage)

macro_optional_find_package(Icecream)
MACRO_OPTIONAL_DEPEND_PACKAGE(KDevPlatform "kdevelop")
if(DEPEND_PACKAGE_KDevPlatform)
	macro_optional_find_package(KDevPlatform)
else(DEPEND_PACKAGE_KDevPlatform)
	set(KDEVPLATFORM_FOUND FALSE)
endif(DEPEND_PACKAGE_KDevPlatform)

macro_log_feature(LIBICECREAM_FOUND "libicecream" "Icecream distributed compilation lib, needed for icemon" "http://en.opensuse.org/Icecream")
macro_log_feature(KDEVPLATFORM_FOUND "kdevplatform" "KDevelop Platform libraries, needed for kdevelop4-extra-plugins" "http://www.kdevelop.org")

add_definitions (${QT_DEFINITIONS} ${KDE4_DEFINITIONS} -DQT3_SUPPORT_WARNINGS -DQT3_SUPPORT)
include_directories (${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${KDE4_INCLUDES} )

add_subdirectory(cmake)
macro_optional_add_subdirectory (doc)

if(LIBICECREAM_FOUND)
	macro_optional_add_subdirectory (icemon)
endif(LIBICECREAM_FOUND)

macro_optional_add_subdirectory(kte_autobrace)
macro_optional_add_subdirectory(kte_quicksnippet)
#doesn't compile: 
# disabled, as kliveui seems disappeared
#macro_optional_add_subdirectory (livedesigner)
#macro_optional_add_subdirectory (smoker)
if(KDEVPLATFORM_FOUND)
	macro_optional_add_subdirectory(kdevelop-pg-qt)
	macro_optional_add_subdirectory(kdevelop4-extra-plugins)
endif(KDEVPLATFORM_FOUND)

if(CMAKE_SOURCE_DIR STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
    macro_display_feature_log()
endif(CMAKE_SOURCE_DIR STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")

=== doc/CMakeLists.txt ===
if(LIBICECREAM_FOUND)
add_subdirectory(icemon)
endif(LIBICECREAM_FOUND)

=== cmake/modules/CMakeLists.txt ===
# install the cmake files

set(cmakeFiles FindIcecream.cmake )
install(FILES ${cmakeFiles} DESTINATION ${DATA_INSTALL_DIR}/cmake/modules )

=== icemon/src/CMakeLists.txt ===
project(icemon)

find_package(Icecream REQUIRED)

include_directories (${LIBICECREAM_INCLUDE_DIR} ${KDE4_INCLUDES})

set(icemon_SRCS
  job.cc
  monitor.cc
  mon-kde.cc
  hostinfo.cc
  statusview.cc
  detailedhostview.cc
  hostlistview.cc
  joblistview.cc
  listview.cc
  ganttstatusview.cc
  summaryview.cc
  starview.cc
  poolview.cc
)

kde4_add_executable(icemon ${icemon_SRCS})

target_link_libraries(icemon ${KDE4_KDEUI_LIBS} ${LIBICECREAM_LIBRARIES} ${QT_QTNETWORK_LIBRARY} ${QT_QT3SUPPORT_LIBRARY})

# -ldl used by icecream
find_library(DL_LIBRARY dl)
if (DL_LIBRARY)
  target_link_libraries(icemon ${DL_LIBRARY})
endif(DL_LIBRARY)

########### install files ###############

install(TARGETS icemon ${INSTALL_TARGETS_DEFAULT_ARGS})

install( FILES icemon.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )
install( FILES icemonui.rc DESTINATION ${DATA_INSTALL_DIR}/icemon )

kde4_install_icons( ${ICON_INSTALL_DIR}   )

## icecc-monitor 2.9.90~git20130612

=== CMakeLists.txt ===
project(icemon)

cmake_minimum_required(VERSION 2.8.5)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

include(GNUInstallDirs)
include(KDE4Macros-Icecream)

# version info
set(ICEMON_VERSION_MAJOR "2")
set(ICEMON_VERSION_MINOR "9")
set(ICEMON_VERSION_PATCH "90")
set(ICEMON_VERSION "${ICEMON_VERSION_MAJOR}.${ICEMON_VERSION_MINOR}.${ICEMON_VERSION_PATCH}")
set(ICEMON_VERSION_STRING "${ICEMON_VERSION}")

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  if(GIT_FOUND)
    execute_process(
      COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE _git_revision
    )
    string(REGEX REPLACE "\n" "" _git_revision "${_git_revision}")
    set(ICEMON_VERSION_STRING "${ICEMON_VERSION_STRING} (revision: ${_git_revision})")
  endif()
endif()

find_package(Qt4 REQUIRED)
find_package(Icecream REQUIRED)

add_definitions(
  ${QT_DEFINITIONS}
)

include_directories(
    ${LIBICECREAM_INCLUDE_DIR}
    ${QT_INCLUDES}
    ${CMAKE_CURRENT_BINARY_DIR} # config-icemon.h
)

set(
  INSTALL_TARGETS_DEFAULT_ARGS
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Devel
)

set(XDG_APPS_INSTALL_DIR ${CMAKE_INSTALL_DATADIR}/applications)
set(ICON_INSTALL_DIR ${CMAKE_INSTALL_DATADIR}/icons)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config-icemon.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config-icemon.h
)

add_subdirectory(src)

# It's not possible to install the docbook right now (Qt-only project)
#add_subdirectory(doc)

=== doc/CMakeLists.txt ===
add_subdirectory(icemon)

=== debian/changelog ===
icecc-monitor (2.9.90~git20130612-1) unstable; urgency=low

  * New Git snapshot.
  * Drop patch 01_fix_armel_build.diff, applied upstream.
  * kdelibs is no more used, so:
    - stop using the kde dh addon
    - remove the pkg-kde-tools and kdelibs5-dev build dependencies
    - add the libqt4-dev build dependency
  * There is no more cmake stuff installed, so stop removing it at
    dh_auto_install time.
  * Bump the cmake build dependency to 2.8.5, as indicated by the upstream
    build system.
  * Override the hyphen-used-as-minus-sign lintian tags, since all the
    man pages shipped are generated from docbook.
  * Add the docbook-xml build dependency for correct man pages regeneration.
  * Switch copyright to copyright-format v1.0, and update it.
  * Update Homepage.
  * Add myself to Uploaders.

 -- Pino Toscano <pino@debian.org>  Wed, 12 Jun 2013 19:13:18 +0200

icecc-monitor (2.0~svn951472-3) unstable; urgency=low

  * Team upload.

  [ Fathi Boudra ]
  * Remove dh_desktop call, deprecated.

  [ Pino Toscano ]
  * Switch source format to "3.0 (quilt)":
    - add debian/source/format file
    - remove quilt usage in rules
    - remove the quilt build dependency
  * Bump debhelper compatibility to 9:
    - bump compat to 9
    - bump the debhelper build dependency to 9
  * Rewrite rules to use the dh sequencer with the kde addon.
  * Bump Standards-Version to 3.9.4, no changes required.
  * Add Vcs-* headers.
  * Link in as-needed mode.
  * Improve description, and fix a typo in it. (Closes: #687352)
  * Since icemon links to the static libicecc, include a Built-Using header
    with the source version of the libicecc-dev package used.
  * Add the pkg-config build dependency.

 -- Pino Toscano <pino@debian.org>  Sun, 26 May 2013 11:37:48 +0200

icecc-monitor (2.0~svn951472-2) unstable; urgency=low

  * Add patch to fix armel build.

 -- Fathi Boudra <fabo@debian.org>  Sat, 11 Apr 2009 09:57:31 +0200

icecc-monitor (2.0~svn951472-1) unstable; urgency=low

  * New svn snapshot. Initial KDE4 version.
  * Remove deprecated patches.
  * Bump compat/debhelper to 7. no changes needed.
  * Switch to debhelper and quilt.
  * Update build dependencies: cmake, pkg-kde-tools, kdelibs5-dev.

 -- Fathi Boudra <fabo@debian.org>  Thu, 09 Apr 2009 12:12:40 +0200

icecc-monitor (1.1-3) unstable; urgency=low

  * Update debian/copyright - fixes copyright-file-contains-full-gfdl-
    license
  * Add Homepage: - fixes description-contains-homepage
  * Update to Standards: 3.8.0 - no changes necessary

 -- Mark Purcell <msp@debian.org>  Sun, 28 Sep 2008 12:51:49 +1000

icecc-monitor (1.1-2) unstable; urgency=low

  * Include gcc4.3 patch from Martin. (Closes: #417227)

 -- Mark Purcell <msp@debian.org>  Fri, 27 Apr 2007 22:39:17 +1000

icecc-monitor (1.1-1) unstable; urgency=low

  * Initial Debian release (Closes: #388327)
  * Merge Andre Woebbeking and Jonathan Riddell package
  * KDE_3_5_BRANCH update (up to r583517)
    * Fix typo license in kabout BSD->GPL_V2
  * Export kde_htmldir to fix doc installation path

 -- Fathi Boudra <fboudra@free.fr>  Mon, 11 Sep 2006 23:15:00 +0200

=== debian/control ===
Source: icecc-monitor
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>, Mark Purcell <msp@debian.org>,
 Pino Toscano <pino@debian.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.5),
 pkg-config,
 libqt4-dev, libicecc-dev,
 docbook2x, docbook-xml
Standards-Version: 3.9.4
Homepage: https://github.com/icecc/icemon
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/icemon/trunk/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/icemon/

Package: icecc-monitor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: icecc
Built-Using: ${icecc:Built-Using}
Description: icecc monitor
 icecc-monitor is a monitoring application for icecc (a distributed compiler).
 It provides a view on the distributed compile network, which jobs run where
 and details about jobs and nodes (statistics and overview information).
 .
 See the 'icecc' package for more information.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

ICECC_DEV_VERSION = $(shell dpkg-query -Wf '$${source:Package} (= $${source:Version})' libicecc-dev)

%:
	dh $@ --parallel

override_dh_auto_clean:
	dh_auto_clean
	rm -f icemon.1

override_dh_auto_build:
	dh_auto_build
	/usr/bin/docbook2x-man debian/icemon.xml

override_dh_installman:
	dh_installman icemon.1

override_dh_gencontrol:
	dh_gencontrol -- -Vicecc:Built-Using='$(ICECC_DEV_VERSION)'

get-orig-source:
	 @@dh_testdir
	 @@[ -d ../tarballs/. ]
	 @@dpatch-get-origtargz ../tarballs

## icecc-monitor 2.9.90~git20140222

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,9 @@
 
 find_package(Qt4 REQUIRED)
 find_package(Icecream REQUIRED)
+find_program(DOCBOOK2X
+  NAMES docbook2x-man docbook-to-man docbook2man.pl
+)
 
 add_definitions(
   ${QT_DEFINITIONS}
@@ -56,6 +59,4 @@
 )
 
 add_subdirectory(src)
-
-# It's not possible to install the docbook right now (Qt-only project)
-#add_subdirectory(doc)
+add_subdirectory(doc)

=== doc/CMakeLists.txt ===
# It's not possible to install the docbook right now (Qt-only project)
#add_subdirectory(icemon)

macro(install_docbook_man_page name section)
  set(inputfn "man-${name}.${section}.xml")
  set(input "${CMAKE_CURRENT_SOURCE_DIR}/${inputfn}")
  set(outputfn "${name}.${section}")
  set(output "${CMAKE_CURRENT_BINARY_DIR}/${outputfn}")
  set(target "manpage-${outputfn}")

  add_custom_command(
    OUTPUT ${output}
    COMMAND ${DOCBOOK2X} ${input}
    DEPENDS ${input}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  )
  add_custom_target(${target} ALL
    DEPENDS "${output}"
  )
  install(
    FILES ${output}
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man${section}
  )
endmacro()

if(DOCBOOK2X)
  install_docbook_man_page(icemon 1)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(images)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
)

set(icemon_SRCS
  fakemonitor.cc
  job.cc
  mainwindow.cc
  monitor.cc
  icecreammonitor.cc
  hostlistmodel.cc
  hostinfo.cc
  statusview.cc
  detailedhostview.cc
  flowtableview.cc
  hostlistview.cc
  joblistmodel.cc
  joblistview.cc
  listview.cc
  ganttstatusview.cc
  summaryview.cc
  starview.cc
  poolview.cc

  main.cc
)

qt4_add_resources(resources_SRCS icemon.qrc)
qt4_automoc(${icemon_SRCS})

add_executable(icemon ${icemon_SRCS} ${resources_SRCS})

target_link_libraries(icemon
    ${LIBICECREAM_LIBRARIES}
    ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIBRARY}
    ${QT_QTNETWORK_LIBRARY}
    ${CMAKE_DL_LIBS}
)

########### install files ###############

install(TARGETS icemon ${INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES icemon.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== debian/changelog ===
icecc-monitor (2.9.90~git20140222-1) unstable; urgency=medium

  * New Git snapshot.
  * Fix build with icecc 1.0.x; patch no-icecc-logging.diff.

 -- Pino Toscano <pino@debian.org>  Sat, 22 Feb 2014 12:19:51 +0100

icecc-monitor (2.9.90~git20131208-1) unstable; urgency=low

  * New Git snapshot.
  * Upstream provides a man page now, so remove icemon.xml, its mention in
    copyright, and its manual build in rules.
  * Bump Standards-Version to 3.9.5, no changes required.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Dec 2013 12:47:40 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  pkg-config,
  libqt4-dev, libicecc-dev,
  docbook2x, docbook-xml
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: https://github.com/icecc/icemon
 Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/icemon/trunk/
 Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/icemon/

=== debian/rules ===
--- 
+++ 
@@ -10,17 +10,6 @@
 %:
 	dh $@ --parallel
 
-override_dh_auto_clean:
-	dh_auto_clean
-	rm -f icemon.1
-
-override_dh_auto_build:
-	dh_auto_build
-	/usr/bin/docbook2x-man debian/icemon.xml
-
-override_dh_installman:
-	dh_installman icemon.1
-
 override_dh_gencontrol:
 	dh_gencontrol -- -Vicecc:Built-Using='$(ICECC_DEV_VERSION)'

## icecc-monitor 3.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,22 @@
 project(icemon)
 
-cmake_minimum_required(VERSION 2.8.5)
+cmake_minimum_required(VERSION 2.8.9)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
+include(CheckCXXCompilerFlag)
+include(CheckCXXSourceCompiles)
 include(GNUInstallDirs)
 include(KDE4Macros-Icecream)
+include(CheckIncludeFileCXX)
+include(FeatureSummary)
 
 # version info
-set(ICEMON_VERSION_MAJOR "2")
-set(ICEMON_VERSION_MINOR "9")
-set(ICEMON_VERSION_PATCH "90")
+set(ICEMON_VERSION_MAJOR "3")
+set(ICEMON_VERSION_MINOR "0")
+set(ICEMON_VERSION_PATCH "0")
 set(ICEMON_VERSION "${ICEMON_VERSION_MAJOR}.${ICEMON_VERSION_MINOR}.${ICEMON_VERSION_PATCH}")
 set(ICEMON_VERSION_STRING "${ICEMON_VERSION}")
 
@@ -27,21 +33,89 @@
   endif()
 endif()
 
-find_package(Qt4 REQUIRED)
-find_package(Icecream REQUIRED)
-find_program(DOCBOOK2X
-  NAMES docbook2x-man docbook-to-man docbook2man.pl
+set(QT_MIN_VERSION "5.2.0")
+find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Core Widgets)
+find_package(Icecream)
+set_package_properties(Icecream PROPERTIES
+  DESCRIPTION "Package providing API for accessing icecc information. Provides 'icecc/comm.h' header"
+  URL "http://en.opensuse.org/Icecream"
+  TYPE REQUIRED
+)
+find_package(Docbook2X)
+set_package_properties(Docbook2X PROPERTIES
+  DESCRIPTION "docbook2X converts DocBook documents into the traditional Unix man page format"
+  PURPOSE "Required for man-page generation"
+  URL "http://docbook2x.sourceforge.net/"
 )
 
+# add a target to generate API documentation with Doxygen
+find_package(Doxygen)
+set_package_properties(Doxygen PROPERTIES
+  TYPE OPTIONAL
+  DESCRIPTION "Doxygen documentation generator"
+  PURPOSE "Needed for generating API documentation (make doc)"
+)
+if(DOXYGEN_FOUND)
+  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
+  add_custom_target(doc
+    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
+    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+    COMMENT "Generating API documentation with Doxygen" VERBATIM
+  )
+endif()
+
+if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+endif()
+
+if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+  check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
+  check_cxx_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wcast-qual -Wcast-align -Wmissing-noreturn -Werror=return-type")
+  if(HAVE_GCC_UNUSED_BUT_SET)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-but-set-variable")
+  endif()
+  if(HAVE_GCC_LOGICAL_OP)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
+  endif()
+endif()
+
 add_definitions(
-  ${QT_DEFINITIONS}
+    -DQT_DEPRECATED_WARNINGS
+    -DQT_DISABLE_DEPRECATED_BEFORE=0x050400
+    -DQT_NO_URL_CAST_FROM_STRING
+    -DQT_STRICT_ITERATORS
+    -DQT_USE_FAST_CONCATENATION
+    -DQT_USE_FAST_OPERATOR_PLUS
+    #-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY
 )
 
 include_directories(
-    ${LIBICECREAM_INCLUDE_DIR}
-    ${QT_INCLUDES}
     ${CMAKE_CURRENT_BINARY_DIR} # config-icemon.h
 )
+
+set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
+if (Icecream_FOUND)
+    check_include_file_cxx(icecc/logging.h ICECC_HAVE_LOGGING_H)
+
+    # Check whether icecc was compiled against old CXXABI
+    # Work-around for: https://github.com/icecc/icemon/issues/24
+    # See: https://gcc.gnu.org/onlinedocs/libstdc++/manual/using_dual_abi.html
+    set(USE_OLDCXXABI_DEFINE -D_GLIBCXX_USE_CXX11_ABI=0)
+    set(CMAKE_REQUIRED_LIBRARIES Icecream)
+    set(CMAKE_REQUIRED_DEFINITIONS ${USE_OLDCXXABI_DEFINE})
+    check_cxx_source_compiles("
+    #include <icecc/comm.h>
+
+    int main() { DiscoverSched sched(\"foo\"); }
+    " ICECC_TEST_USE_OLDABI)
+
+    if (ICECC_TEST_USE_OLDABI)
+        message(STATUS "Tests indicated icecc was linked against old GCC ABI, adding ${USE_OLDCXXABI_DEFINE} define")
+        add_definitions(${USE_OLDCXXABI_DEFINE})
+    endif()
+endif()
 
 set(
   INSTALL_TARGETS_DEFAULT_ARGS
@@ -60,3 +134,5 @@
 
 add_subdirectory(src)
 add_subdirectory(doc)
+
+feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
add_subdirectory(images)

set(icemon_SRCS
  fakemonitor.cc
  hostinfo.cc
  icecreammonitor.cc
  job.cc
  main.cc
  mainwindow.cc
  monitor.cc
  statusview.cc
  statusviewfactory.cc
  utils.cc

  models/hostlistmodel.cc
  models/joblistmodel.cc

  views/detailedhostview.cc
  views/flowtableview.cc
  views/ganttstatusview.cc
  views/hostlistview.cc
  views/joblistview.cc
  views/listview.cc
  #views/poolview.cc
  views/starview.cc
  views/summaryview.cc
)

qt5_add_resources(resources_SRCS icemon.qrc)
add_executable(icemon ${icemon_SRCS} ${resources_SRCS})
target_link_libraries(icemon
    Icecream
    Qt5::Widgets
)

install(TARGETS icemon ${INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES icemon.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== debian/changelog ===
icecc-monitor (3.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update patches:
    - upstream_Add-missing-include-on-Qt-5.5-fixes-build.patch: drop,
      backported
  * Bump Standards-Version to 3.9.7, no changes required.
  * Use https for the Vcs-Browser field.

 -- Pino Toscano <pino@debian.org>  Sat, 13 Feb 2016 17:40:05 +0100

icecc-monitor (3.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop patch no-icecc-logging.diff, applied upstream.
  * Upstream switched from Qt4 to Qt5, so:
    - replace the libqt4-dev build dependency with qtbase5-dev
    - set QT_SELECT in rules to force the usage of Qt5
  * Bump cmake build dependency to >= 2.8.9, as indicated in the upstream
    CMakeLists.txt.
  * Add a watch file.
  * Backport upstream commit a772b1e7855e307266ea98cf3f73fcbd24429846 to
    include a needed header, fixing the build with Qt 5.5; patch
    upstream_Add-missing-include-on-Qt-5.5-fixes-build.patch.
  * Slightly tweak short description.
  * Bump Standards-Version to 3.9.6, no changes required.
  * Remove lintian override for hyphen-used-as-minus-sign, as it seems no more
    needed now.
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Sun, 29 Nov 2015 09:38:43 +0100

=== debian/control ===
Source: icecc-monitor
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>, Mark Purcell <msp@debian.org>,
 Pino Toscano <pino@debian.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.9),
 pkg-config,
 qtbase5-dev (>= 5.2), libicecc-dev,
 docbook2x, docbook-xml
Standards-Version: 3.9.7
Homepage: https://github.com/icecc/icemon
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/icemon/trunk/
Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-kde/kde-extras/icemon/

Package: icecc-monitor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: icecc
Built-Using: ${icecc:Built-Using}
Description: monitor for icecc
 icecc-monitor is a monitoring application for icecc (a distributed compiler).
 It provides a view on the distributed compile network, which jobs run where
 and details about jobs and nodes (statistics and overview information).
 .
 See the 'icecc' package for more information.

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,8 @@
 #export DH_VERBOSE=1
 
 export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
+
+export QT_SELECT := 5
 
 ICECC_DEV_VERSION = $(shell dpkg-query -Wf '$${source:Package} (= $${source:Version})' libicecc-dev)

## icecc-monitor 3.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 # version info
 set(ICEMON_VERSION_MAJOR "3")
-set(ICEMON_VERSION_MINOR "0")
+set(ICEMON_VERSION_MINOR "1")
 set(ICEMON_VERSION_PATCH "0")
 set(ICEMON_VERSION "${ICEMON_VERSION_MAJOR}.${ICEMON_VERSION_MINOR}.${ICEMON_VERSION_PATCH}")
 set(ICEMON_VERSION_STRING "${ICEMON_VERSION}")
@@ -71,7 +71,7 @@
 if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
   check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
   check_cxx_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wcast-qual -Wcast-align -Wmissing-noreturn -Werror=return-type")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wcast-qual -Wcast-align -Wmissing-noreturn -Werror=return-type -pedantic")
   if(HAVE_GCC_UNUSED_BUT_SET)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-but-set-variable")
   endif()
@@ -83,11 +83,13 @@
 add_definitions(
     -DQT_DEPRECATED_WARNINGS
     -DQT_DISABLE_DEPRECATED_BEFORE=0x050400
+    -DQT_NO_CAST_FROM_ASCII
+    -DQT_NO_CAST_FROM_BYTEARRAY
+    -DQT_NO_CAST_TO_ASCII
     -DQT_NO_URL_CAST_FROM_STRING
     -DQT_STRICT_ITERATORS
     -DQT_USE_FAST_CONCATENATION
     -DQT_USE_FAST_OPERATOR_PLUS
-    #-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY
 )
 
 include_directories(

=== debian/changelog ===
icecc-monitor (3.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.8, no changes required.

 -- Pino Toscano <pino@debian.org>  Sun, 18 Jun 2017 07:46:42 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  pkg-config,
  qtbase5-dev (>= 5.2), libicecc-dev,
  docbook2x, docbook-xml
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: https://github.com/icecc/icemon
 Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/icemon/trunk/
 Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-kde/kde-extras/icemon/

## icecc-monitor 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 # version info
 set(ICEMON_VERSION_MAJOR "3")
-set(ICEMON_VERSION_MINOR "1")
+set(ICEMON_VERSION_MINOR "2")
 set(ICEMON_VERSION_PATCH "0")
 set(ICEMON_VERSION "${ICEMON_VERSION_MAJOR}.${ICEMON_VERSION_MINOR}.${ICEMON_VERSION_PATCH}")
 set(ICEMON_VERSION_STRING "${ICEMON_VERSION}")

=== debian/changelog ===
icecc-monitor (3.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Switch Vcs-* fields to salsa.debian.org.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Remove Fathi Boudra from Uploaders, as requested by the MIA team.
    (Closes: #879301)
  * Remove the get-orig-source target from rules, as it was broken for a long
    time (refers to dpatch, and SVN).
  * Bump Standards-Version to 4.2.1, no changes required.
  * Remove empty line at the end of changelog.
  * Use https for Format in copyright.
  * Bump the libicecc-dev build dependency to >= 1.2, to make sure to use the
    newer icecc static library.

 -- Pino Toscano <pino@debian.org>  Fri, 21 Dec 2018 16:07:54 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,16 @@
 Section: kde
 Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
-Uploaders: Fathi Boudra <fabo@debian.org>, Mark Purcell <msp@debian.org>,
+Uploaders: Mark Purcell <msp@debian.org>,
  Pino Toscano <pino@debian.org>
-Build-Depends: debhelper (>= 9), cmake (>= 2.8.9),
+Build-Depends: debhelper (>= 11~), cmake (>= 2.8.9),
  pkg-config,
- qtbase5-dev (>= 5.2), libicecc-dev,
+ qtbase5-dev (>= 5.2), libicecc-dev (>= 1.2~),
  docbook2x, docbook-xml
-Standards-Version: 3.9.8
+Standards-Version: 4.2.1
 Homepage: https://github.com/icecc/icemon
-Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/icemon/trunk/
-Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-kde/kde-extras/icemon/
+Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/icemon.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/icemon
 
 Package: icecc-monitor
 Architecture: any

## icecc-monitor 3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,24 +1,20 @@
-project(icemon)
+cmake_minimum_required(VERSION 3.1.0)
+project(icemon VERSION 3.3)
 
-cmake_minimum_required(VERSION 2.8.9)
+find_package(ECM REQUIRED NO_MODULE)
 
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
 include(CheckCXXCompilerFlag)
 include(CheckCXXSourceCompiles)
 include(GNUInstallDirs)
-include(KDE4Macros-Icecream)
 include(CheckIncludeFileCXX)
 include(FeatureSummary)
+include(ECMInstallIcons)
 
-# version info
-set(ICEMON_VERSION_MAJOR "3")
-set(ICEMON_VERSION_MINOR "2")
-set(ICEMON_VERSION_PATCH "0")
-set(ICEMON_VERSION "${ICEMON_VERSION_MAJOR}.${ICEMON_VERSION_MINOR}.${ICEMON_VERSION_PATCH}")
-set(ICEMON_VERSION_STRING "${ICEMON_VERSION}")
+set(ICEMON_VERSION_STRING "${PROJECT_VERSION}")
 
 if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
   find_package(Git)
@@ -33,7 +29,7 @@
   endif()
 endif()
 
-set(QT_MIN_VERSION "5.2.0")
+set(QT_MIN_VERSION "5.4.0") # Because of QByteArray::fromStdString
 find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Core Widgets)
 find_package(Icecream)
 set_package_properties(Icecream PROPERTIES
@@ -64,11 +60,11 @@
   )
 endif()
 
-if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
+if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 endif()
 
-if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
   check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
   check_cxx_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wcast-qual -Wcast-align -Wmissing-noreturn -Werror=return-type -pedantic")
@@ -138,3 +134,9 @@
 add_subdirectory(doc)
 
 feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)
+
+set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
+add_custom_target(dist
+    COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD
+        | xz -T0 > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.xz
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== doc/CMakeLists.txt ===
# It's not possible to install the docbook right now (Qt-only project)
#add_subdirectory(icemon)

if(DOCBOOK_TO_MAN_EXECUTABLE)
  install_docbook_man_page(icemon 1)
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,6 @@
   views/hostlistview.cc
   views/joblistview.cc
   views/listview.cc
-  #views/poolview.cc
   views/starview.cc
   views/summaryview.cc
 )

=== src/images/CMakeLists.txt ===
set(icons
  128-apps-icemon.png
  16-apps-icemon.png
  22-apps-icemon.png
  32-apps-icemon.png
  48-apps-icemon.png
)
ecm_install_icons(
  ICONS ${icons}
  DESTINATION ${ICON_INSTALL_DIR}
  THEME hicolor
)

=== debian/changelog ===
icecc-monitor (3.3-3) unstable; urgency=medium

  * Backport upstream commit b07bf3eb0c28ac5cd527d3ab675d2273d1866b48 to build
    with cmake 4; patch upstream_Fix-build-with-CMake-4.0.patch.
    (Closes: #1113002)
  * Bump Standards-Version to 4.7.2, no changes required.
  * Simplify GPL license text in copyright.
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Remove inactive Uploaders.

 -- Pino Toscano <pino@debian.org>  Mon, 01 Sep 2025 07:58:46 +0200

icecc-monitor (3.3-2) unstable; urgency=medium

  * Bump watch file to v4, no changes required.
  * Add the configuration for the CI on salsa.
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.0, no changes needed.
  * Remove the explicit as-needed linking, as it is done by binutils now.
  * Add Rules-Requires-Root: no.

 -- Pino Toscano <pino@debian.org>  Sat, 05 Mar 2022 10:04:30 +0100

icecc-monitor (3.3-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.1.0
    - bump qtbase5-dev to 5.4.0
    - bump libicecc-dev to 1.3
    - add extra-cmake-modules
  * Bump Standards-Version to 4.4.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 14 Sep 2019 12:56:00 +0200

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,14 @@
 Section: kde
 Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
-Uploaders: Mark Purcell <msp@debian.org>,
- Pino Toscano <pino@debian.org>
-Build-Depends: debhelper (>= 11~), cmake (>= 2.8.9),
- pkg-config,
- qtbase5-dev (>= 5.2), libicecc-dev (>= 1.2~),
+Uploaders: Pino Toscano <pino@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake (>= 3.1.0),
+ extra-cmake-modules,
+ pkgconf,
+ qtbase5-dev (>= 5.4.0), libicecc-dev (>= 1.3~),
  docbook2x, docbook-xml
-Standards-Version: 4.2.1
+Standards-Version: 4.7.2
+Rules-Requires-Root: no
 Homepage: https://github.com/icecc/icemon
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/icemon.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/icemon

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT := 5

ICECC_DEV_VERSION = $(shell dpkg-query -Wf '$${source:Package} (= $${source:Version})' libicecc-dev)

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol -- -Vicecc:Built-Using='$(ICECC_DEV_VERSION)'

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/icecc-monitor-$1\.tar\.gz/ \
  https://github.com/icecc/icemon/tags .*/v?(\d\S*)\.tar\.gz
